#!/usr/bin/python

__doc__ = """Boost Software License - Version 1.0 - August 17th, 2003

Permission is hereby granted, free of charge, to any person or organization
obtaining a copy of the software and accompanying documentation covered by
this license (the "Software") to use, reproduce, display, distribute,
execute, and transmit the Software, and to prepare derivative works of the
Software, and to permit third-parties to whom the Software is furnished to
do so, all subject to the following:

The copyright notices in the Software and this entire statement, including
the above license grant, this restriction and the following disclaimer,
must be included in all copies of the Software, in whole or in part, and
all derivative works of the Software, unless such copies or derivative
works are solely in the form of machine-executable object code generated by
a source language processor.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE, TITLE AND NON-INFRINGEMENT. IN NO EVENT
SHALL THE COPYRIGHT HOLDERS OR ANYONE DISTRIBUTING THE SOFTWARE BE LIABLE
FOR ANY DAMAGES OR OTHER LIABILITY, WHETHER IN CONTRACT, TORT OR OTHERWISE,
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
DEALINGS IN THE SOFTWARE."""

import os
import results

verbose = False
#verbose = True

class playground:
    def __init__(self,pathtogamefield):
        file = open(pathtogamefield)
 
        fieldlist = file.readlines()
	self.field = []

	for line in fieldlist:
	    self.field.append(line.split())
	
    def __repr__(self):
        string = '   '
	
	for index in range(0,10): string += " %d   " % index
	string += "\n"
	
        for index,line in enumerate(self.field):
	    string += "%d %s" %(index , str(line) + "\n")

        return string
    
    def makemoveandreduce(self,move,result):
        self.makemove(move)
	self.reducecomplete(result)

    def reducecomplete(self,result):

        reduceresult = True
        
        while reduceresult == True:
	    if verbose: print "Prereduce: \n %s" % str(self)
            reduceresult = self.reduce(result)
	    if verbose: print "Postreduce: \n %s" % str(self)
    
    def checkcount(self,lineindex,colindex,lastval,count):
	val = self.field[lineindex][colindex]
	if val == '*' or val == '_': 
	    return 0,val

        if ((lastval == val) or (lastval.isdigit() and val.isdigit())):
	    count += 1
	elif (lastval != val):
	    count = 1

	return count,val

    def reduce(self,result):
        #holding the indexes of removeable fields
	removingindexeslines = []
	removingindexescols = []
	#get all indexes for removable fields
	removingindexes = []
        
	for lineindex in range(len(self.field)):
	    #set up values
	    lastval = ''
	    count = 1
	    for colindex in range(len(self.field)):
	        # lastvalue need to be same or a digits in case of bombs
		count,lastval = self.checkcount(lineindex,colindex,lastval,count)
	        if count >= 3:
		   #yeah we found a three or more combo
	            if verbose: print "Line: (%s <-> %s) %d at (%d/%d)"% (self.field[lineindex][colindex],lastval,count,lineindex,colindex)
		    for remcol in range(0,count):
		        #only if index not found for line until now add it to the list
		        try:
			    removingindexeslines.index((lineindex,colindex-remcol))
			except ValueError:
		            removingindexeslines.append((lineindex,colindex-remcol))

        for colindex in range(len(self.field)):
	    #set up values
	    lastval = ''
	    count = 1
	    for lineindex in range(len(self.field)):
	        # lastvalue need to be same or a digits in case of bombs
		count,lastval = self.checkcount(lineindex,colindex,lastval,count)
		if count >= 3:
		    #yeah we found a three or more combo
	            if verbose: print "Colmn: (%s <-> %s) %d at (%d/%d)"% (self.field[lineindex][colindex],lastval,count,lineindex,colindex)
		    for remline in range(0,count):
		        #only if index not found in cols until now it will be added to the list
		        try:
			    removingindexescols.index((lineindex-remline,colindex))
			except:
		            removingindexescols.append((lineindex-remline,colindex))

        #build list with complete indexes
        removingindexes = removingindexeslines + removingindexescols

        #remove doubled entrys for loop remove all doubled indexes
        cleanremovingindexes = set(removingindexes)

	for lindex,cindex in cleanremovingindexes:
	    val = self.field[lindex][cindex]
	    #if the value is contained more than once in the removingindexes list
	    #we will hit a bug in the game engine which counts corners double.
	    if val.isdigit():
	        result.values['Bomb'] += int(val) * removingindexes.count((lindex,cindex))
		#result.values['Bomb'] += int(val)
	    else:
	        result.values[val] += 1 * removingindexes.count((lindex,cindex))
		#result.values[val] += 1

	    self.field[lindex][cindex] = '*'
	
	#make the lines to columns 
	reducer = []
        for colindex in range(len(self.field)):
	    reducer.append([])
	    for lineindex in range(len(self.field)):
	        if self.field[lineindex][colindex] != '*':
	            reducer[colindex] += self.field[lineindex][colindex]
		else:
		    reducer[colindex].insert(0,'*')

	self.field = []
	for colindex in range(len(reducer)):
	    self.field.append([])
	    for lineindex in range(len(reducer)):
	            self.field[colindex] += reducer[lineindex][colindex]
	
	if verbose: print result
	return len(removingindexes) > 0

    def makemove(self,move):
        self.field[move[0]][move[1]],self.field[move[2]][move[3]] = self.field[move[2]][move[3]],self.field[move[0]][move[1]]

if __name__ == "__main__":
    
    testreduce = False
    testmove = False
    testmoveandreduce = True

    if testreduce == True:
        test = playground(os.getcwd() + r"/testfield.dat")
        result = results.results()
        print test
	test.reducecomplete(result)
        print result
        print test

    if testmove == True:
        test = playground(os.getcwd() + r"/testfield.dat")
        print test
	test.makemove((0,0,0,1))
	print test
   
    if testmoveandreduce == True:
        test = playground(os.getcwd() + r"/testfield.dat")
        result = results.results()
        print test
	test.makemoveandreduce((7,1,6,1),result)
        print result
        print test
